SdFat

Public Member Functions | List of all members
ExFile Class Reference

exFAT file with Arduino Stream. More...

`#include <ExFatFile.h>`

Inheritance diagram for ExFile:
[legend]
Collaboration diagram for ExFile:
[legend]

## Public Member Functions
int | available ()
uint64_t | available64 ()
void | clearError ()
void | clearWriteError ()
bool | close ()
bool | contiguousRange (uint32_t *bgnSector, uint32_t *endSector)
uint64_t | curPosition () const
uint64_t | dataLength ()
uint32_t | dirIndex ()
bool | exists (const ExChar_t *path)
void | fgetpos (fspos_t *pos)
int | fgets (char *str, int num, char *delim=NULL)
uint64_t | fileSize ()
uint32_t | firstSector ()
void | flush ()
void | fsetpos (const fspos_t *pos)
bool | getAccessDateTime (uint16_t *pdate, uint16_t *ptime)
bool | getCreateDateTime (uint16_t *pdate, uint16_t *ptime)
uint8_t | getError ()
bool | getModifyDateTime (uint16_t *pdate, uint16_t *ptime)
size_t | getName (ExChar_t *name, size_t size)
bool | getWriteError ()
bool | isContiguous () const
bool | isDir () const
bool | isDirectory ()
bool | isFile () const
bool | isHidden () const
bool | isOpen () const
bool | isReadable () const
bool | isReadOnly () const
bool | isRoot () const
bool | isSubDir () const
bool | isWritable () const
bool | ls (print_t *pr)
bool | ls (print_t *pr, uint8_t flags, uint8_t indent=0)
bool | mkdir (ExFatFile *parent, const ExChar_t *path, bool pFlag=true)
const char * | name () const
bool | open (const ExChar_t *path, int oflag=0X00)
bool | open (ExFatFile *dirFile, const ExChar_t *path, oflag_t oflag)
bool | open (ExFatFile *dirFile, uint32_t index, oflag_t oflag)
bool | open (ExFatVolume *vol, const ExChar_t *path, int oflag)
bool | openNext (ExFatFile *dirFile, oflag_t oflag=0X00)
ExFile | openNextFile (oflag_t oflag=0X00)
bool | openRoot (ExFatVolume *vol)
| operator bool ()
int | peek ()
uint64_t | position ()
bool | preAllocate (uint64_t length)
size_t | printAccessDateTime (print_t *pr)
size_t | printCreateDateTime (print_t *pr)
size_t | printField (double value, char term, uint8_t prec=2)
size_t | printField (float value, char term, uint8_t prec=2)
template<typename Type >
size_t | printField (Type value, char term)
size_t | printFileSize (print_t *pr)
size_t | printModifyDateTime (print_t *pr)
size_t | printName (print_t *pr)
int | read ()
int | read (void *buf, size_t count)
bool | remove ()
bool | remove (const ExChar_t *path)
bool | rename (const ExChar_t *newPath)
bool | rename (ExFatFile *dirFile, const ExChar_t *newPath)
void | rewind ()
void | rewindDirectory ()
bool | rmdir ()
bool | seek (uint64_t pos)
bool | seekCur (int64_t offset)
bool | seekEnd (int64_t offset=0)
bool | seekSet (uint64_t pos)
uint64_t | size ()
bool | sync ()
bool | timestamp (uint8_t flags, uint16_t year, uint8_t month, uint8_t day, uint8_t hour, uint8_t minute, uint8_t second)
bool | truncate ()
bool | truncate (uint64_t length)
uint64_t | validLength ()
size_t | write (const char *str)
size_t | write (const uint8_t *buffer, size_t size)
size_t | write (const void *buf, size_t count)
size_t | write (uint8_t b)

## Detailed Description

exFAT file with Arduino Stream.

## Member Function Documentation

## ◆ available()

int StreamFile< ExFatFile , uint64_t >::available | ( |  | ) |
| inline inherited

Returns
  number of bytes available from the current position to EOF or INT_MAX if more than INT_MAX bytes are available.

## ◆ available64()

uint64_t ExFatFile::available64 | ( |  | ) |
| inline inherited

Returns
  The number of bytes available from the current position to EOF for normal files. Zero is returned for directory files.

## ◆ clearError()

void ExFatFile::clearError | ( |  | ) |
| inline inherited

Clear all error bits.

## ◆ clearWriteError()

void ExFatFile::clearWriteError | ( |  | ) |
| inline inherited

Clear writeError.

## ◆ close()

bool ExFatFile::close | ( |  | ) |
| inherited

Close a file and force cached data and directory information to be written to the storage device.

Returns
  true for success or false for failure.

## ◆ contiguousRange()

bool ExFatFile::contiguousRange | ( | uint32_t * | bgnSector,
|  | uint32_t * | endSector
| ) |  |
| inherited

Check for contiguous file and return its raw sector range.

Parameters

  [out] | bgnSector | the first sector address for the file.
  [out] | endSector | the last sector address for the file.

Parameters may be nullptr.

Returns
  true for success or false for failure.

## ◆ curPosition()

uint64_t ExFatFile::curPosition | ( |  | ) | const
| inline inherited

Returns
  The current position for a file or directory.

## ◆ dataLength()

uint64_t ExFatFile::dataLength | ( |  | ) |
| inline inherited

Returns
  Total data length for file.

## ◆ dirIndex()

uint32_t ExFatFile::dirIndex | ( |  | ) |
| inline inherited

Returns
  Directory entry index.

## ◆ exists()

bool ExFatFile::exists | ( | const ExChar_t * | path | ) |
| inline inherited

Test for the existence of a file in a directory

Parameters

  [in] | path | Path of the file to be tested for.

The calling instance must be an open directory file.

dirFile.exists("TOFIND.TXT") searches for "TOFIND.TXT" in the directory dirFile.

Returns
  true if the file exists else false.

## ◆ fgetpos()

void ExFatFile::fgetpos | ( | fspos_t * | pos | ) |
| inherited

get position for streams

Parameters

  [out] | pos | struct to receive position

## ◆ fgets()

int ExFatFile::fgets | ( | char * | str,
|  | int | num,
|  | char * | delim = `NULL`
| ) |  |
| inherited

Get a string from a file.

fgets() reads bytes from a file into the array pointed to by str, until num - 1 bytes are read, or a delimiter is read and transferred to str, or end-of-file is encountered. The string is then terminated with a null byte.

fgets() deletes CR, '\r', from the string. This insures only a '\n' terminates the string for Windows text files which use CRLF for newline.

Parameters

  [out] | str | Pointer to the array where the string is stored.
  [in] | num | Maximum number of characters to be read (including the final null byte). Usually the length of the array str is used.
  [in] | delim | Optional set of delimiters. The default is "\n".

Returns
  For success fgets() returns the length of the string in str. If no data is read, fgets() returns zero for EOF or -1 if an error occurred.

## ◆ fileSize()

uint64_t ExFatFile::fileSize | ( |  | ) |
| inline inherited

Returns
  The total number of bytes in a file.

## ◆ firstSector()

uint32_t ExFatFile::firstSector | ( |  | ) |
| inherited

Returns
  Address of first sector or zero for empty file.

## ◆ flush()

void StreamFile< ExFatFile , uint64_t >::flush | ( |  | ) |
| inline inherited

Ensure that any bytes written to the file are saved to the SD card.

## ◆ fsetpos()

void ExFatFile::fsetpos | ( | const fspos_t * | pos | ) |
| inherited

Set position for streams

Parameters

  [in] | pos | struct with value for new position

## ◆ getAccessDateTime()

bool ExFatFile::getAccessDateTime | ( | uint16_t * | pdate,
|  | uint16_t * | ptime
| ) |  |
| inherited

Get a file's access date and time.

Parameters

  [out] | pdate | Packed date for directory entry.
  [out] | ptime | Packed time for directory entry.

Returns
  true for success or false for failure.

## ◆ getCreateDateTime()

bool ExFatFile::getCreateDateTime | ( | uint16_t * | pdate,
|  | uint16_t * | ptime
| ) |  |
| inherited

Get a file's create date and time.

Parameters

  [out] | pdate | Packed date for directory entry.
  [out] | ptime | Packed time for directory entry.

Returns
  true for success or false for failure.

## ◆ getError()

uint8_t ExFatFile::getError | ( |  | ) |
| inline inherited

Returns
  All error bits.

## ◆ getModifyDateTime()

bool ExFatFile::getModifyDateTime | ( | uint16_t * | pdate,
|  | uint16_t * | ptime
| ) |  |
| inherited

Get a file's modify date and time.

Parameters

  [out] | pdate | Packed date for directory entry.
  [out] | ptime | Packed time for directory entry.

Returns
  true for success or false for failure.

## ◆ getName()

size_t ExFatFile::getName | ( | ExChar_t * | name,
|  | size_t | size
| ) |  |
| inherited

Get a file's name followed by a zero byte.

Parameters

  [out] | name | An array of characters for the file's name.
  [in] | size | The size of the array in characters.

Returns
  the name length.

## ◆ getWriteError()

bool ExFatFile::getWriteError | ( |  | ) |
| inline inherited

Returns
  value of writeError

## ◆ isContiguous()

bool ExFatFile::isContiguous | ( |  | ) | const
| inline inherited

Returns
  True if the file is contiguous.

## ◆ isDir()

bool ExFatFile::isDir | ( |  | ) | const
| inline inherited

Returns
  True if this is a directory.

## ◆ isDirectory()

bool StreamFile< ExFatFile , uint64_t >::isDirectory | ( |  | ) |
| inline inherited

This function reports if the current file is a directory or not.

Returns
  true if the file is a directory.

## ◆ isFile()

bool ExFatFile::isFile | ( |  | ) | const
| inline inherited

Returns
  True if this is a normal file.

## ◆ isHidden()

bool ExFatFile::isHidden | ( |  | ) | const
| inline inherited

Returns
  True if this is a hidden.

## ◆ isOpen()

bool ExFatFile::isOpen | ( |  | ) | const
| inline inherited

Returns
  true if the file is open.

## ◆ isReadable()

bool ExFatFile::isReadable | ( |  | ) | const
| inline inherited

Returns
  True file is writable.

## ◆ isReadOnly()

bool ExFatFile::isReadOnly | ( |  | ) | const
| inline inherited

Returns
  True if file is read-only

## ◆ isRoot()

bool ExFatFile::isRoot | ( |  | ) | const
| inline inherited

Returns
  True if this is the root directory.

## ◆ isSubDir()

bool ExFatFile::isSubDir | ( |  | ) | const
| inline inherited

Returns
  True if this is a subdirectory.

## ◆ isWritable()

bool ExFatFile::isWritable | ( |  | ) | const
| inline inherited

Returns
  True file is writable.

## ◆ ls() [1/2]

bool ExFatFile::ls | ( | print_t * | pr | ) |
| inherited

List directory contents.

Parameters

  [in] | pr | Print stream for list.

Returns
  true for success or false for failure.

## ◆ ls() [2/2]

bool ExFatFile::ls | ( | print_t * | pr,
|  | uint8_t | flags,
|  | uint8_t | indent = `0`
| ) |  |
| inherited

List directory contents.

Parameters

  [in] | pr | Print stream for list.
  [in] | flags | The inclusive OR of

LS_DATE - Print file modification date

LS_SIZE - Print file size.

LS_R - Recursive list of subdirectories.

Parameters

  [in] | indent | Amount of space before file name. Used for recursive list to indicate subdirectory level.

Returns
  true for success or false for failure.

## ◆ mkdir()

bool ExFatFile::mkdir | ( | ExFatFile * | parent,
|  | const ExChar_t * | path,
|  | bool | pFlag = `true`
| ) |  |
| inherited

Make a new directory.

Parameters

  [in] | parent | An open directory file that will contain the new directory.
  [in] | path | A path with a valid name for the new directory.
  [in] | pFlag | Create missing parent directories if true.

Returns
  true for success or false for failure.

## ◆ name()

const char* StreamFile< ExFatFile , uint64_t >::name | ( |  | ) | const
| inline inherited

No longer implemented due to Long File Names.

Use getName(char* name, size_t size).

Returns
  a pointer to replacement suggestion.

## ◆ open() [1/4]

bool ExFatFile::open | ( | const ExChar_t * | path,
|  | int | oflag = `0X00`
| ) |  |
| inherited

Open a file in the current working directory.

Parameters

  [in] | path | A path with a valid name for a file to be opened.
  [in] | oflag | bitwise-inclusive OR of open flags. See see ExFatFile::open(ExFatFile*, const char*, uint8_t).

Returns
  true for success or false for failure.

## ◆ open() [2/4]

bool ExFatFile::open | ( | ExFatFile * | dirFile,
|  | const ExChar_t * | path,
|  | oflag_t | oflag
| ) |  |
| inherited

Open a file or directory by name.

Parameters

  [in] | dirFile | An open directory containing the file to be opened.
  [in] | path | The path for a file to be opened.
  [in] | oflag | Values for oflag are constructed by a bitwise-inclusive OR of flags from the following list. Only one of O_RDONLY, O_READ, O_WRONLY, O_WRITE, or O_RDWR is allowed.

O_RDONLY - Open for reading.

O_READ - Same as O_RDONLY.

O_WRONLY - Open for writing.

O_WRITE - Same as O_WRONLY.

O_RDWR - Open for reading and writing.

O_APPEND - If set, the file offset shall be set to the end of the file prior to each write.

O_AT_END - Set the initial position at the end of the file.

O_CREAT - If the file exists, this flag has no effect except as noted under O_EXCL below. Otherwise, the file shall be created

O_EXCL - If O_CREAT and O_EXCL are set, open() shall fail if the file exists.

O_TRUNC - If the file exists and is a regular file, and the file is successfully opened and is not read only, its length shall be truncated to 0.

WARNING: A given file must not be opened by more than one file object or file corruption may occur.

Note
  Directory files must be opened read only. Write and truncation is not allowed for directory files.

Returns
  true for success or false for failure.

## ◆ open() [3/4]

bool ExFatFile::open | ( | ExFatFile * | dirFile,
|  | uint32_t | index,
|  | oflag_t | oflag
| ) |  |
| inherited

Open a file by index.

Parameters

  [in] | dirFile | An open ExFatFile instance for the directory.
  [in] | index | The index of the directory entry for the file to be opened. The value for index is (directory file position)/32.
  [in] | oflag | bitwise-inclusive OR of open flags. See see ExFatFile::open(ExFatFile*, const ExChar_t*, uint8_t).

See open() by path for definition of flags.

Returns
  true for success or false for failure.

## ◆ open() [4/4]

bool ExFatFile::open | ( | ExFatVolume * | vol,
|  | const ExChar_t * | path,
|  | int | oflag
| ) |  |
| inherited

Open a file in the volume working directory.

Parameters

  [in] | vol | Volume where the file is located.
  [in] | path | with a valid name for a file to be opened.
  [in] | oflag | bitwise-inclusive OR of open flags. See see open(ExFatFile*, const char*, uint8_t).

Returns
  true for success or false for failure.

## ◆ openNext()

bool ExFatFile::openNext | ( | ExFatFile * | dirFile,
|  | oflag_t | oflag = `0X00`
| ) |  |
| inherited

Open the next file or subdirectory in a directory.

Parameters

  [in] | dirFile | An open instance for the directory containing the file to be opened.
  [in] | oflag | bitwise-inclusive OR of open flags. See see open(ExFatFile*, const char*, uint8_t).

Returns
  true for success or false for failure.

## ◆ openNextFile()

ExFile ExFile::openNextFile | ( | oflag_t | oflag = `0X00` | ) |
| inline

Opens the next file or folder in a directory.

Parameters

  [in] | oflag | open flags.

Returns
  a FatStream object.

## ◆ openRoot()

bool ExFatFile::openRoot | ( | ExFatVolume * | vol | ) |
| inherited

Open a volume's root directory.

Parameters

  [in] | vol | The FAT volume containing the root directory to be opened.

Returns
  true for success or false for failure.

## ◆ operator bool()

ExFatFile::operator bool | ( |  | ) |
| inline inherited

The parenthesis operator.

Returns
  true if a file is open.

## ◆ peek()

int StreamFile< ExFatFile , uint64_t >::peek | ( |  | ) |
| inline inherited

Return the next available byte without consuming it.

Returns
  The byte if no error and not at eof else -1;

## ◆ position()

uint64_t StreamFile< ExFatFile , uint64_t >::position | ( |  | ) |
| inline inherited

Returns
  the current file position.

## ◆ preAllocate()

bool ExFatFile::preAllocate | ( | uint64_t | length | ) |
| inherited

Allocate contiguous clusters to an empty file.

The file must be empty with no clusters allocated.

The file will have zero validLength and dataLength will equal the requested length.

Parameters

  [in] | length | size of allocated space in bytes.

Returns
  true for success or false for failure.

## ◆ printAccessDateTime()

size_t ExFatFile::printAccessDateTime | ( | print_t * | pr | ) |
| inherited

Print a file's access date and time

Parameters

  [in] | pr | Print stream for output.

Returns
  true for success or false for failure.

## ◆ printCreateDateTime()

size_t ExFatFile::printCreateDateTime | ( | print_t * | pr | ) |
| inherited

Print a file's creation date and time

Parameters

  [in] | pr | Print stream for output.

Returns
  true for success or false for failure.

## ◆ printField() [1/3]

size_t ExFatFile::printField | ( | double | value,
|  | char | term,
|  | uint8_t | prec = `2`
| ) |  |
| inline inherited

Print a number followed by a field terminator.

Parameters

  [in] | value | The number to be printed.
  [in] | term | The field terminator. Use '\n' for CR LF.
  [in] | prec | Number of digits after decimal point.

Returns
  The number of bytes written or -1 if an error occurs.

## ◆ printField() [2/3]

size_t ExFatFile::printField | ( | float | value,
|  | char | term,
|  | uint8_t | prec = `2`
| ) |  |
| inline inherited

Print a number followed by a field terminator.

Parameters

  [in] | value | The number to be printed.
  [in] | term | The field terminator. Use '\n' for CR LF.
  [in] | prec | Number of digits after decimal point.

Returns
  The number of bytes written or -1 if an error occurs.

## ◆ printField() [3/3]

template<typename Type >

size_t ExFatFile::printField | ( | Type | value,
|  | char | term
| ) |  |
| inline inherited

Print a number followed by a field terminator.

Parameters

  [in] | value | The number to be printed.
  [in] | term | The field terminator. Use '\n' for CR LF.

Returns
  The number of bytes written or -1 if an error occurs.

## ◆ printFileSize()

size_t ExFatFile::printFileSize | ( | print_t * | pr | ) |
| inherited

Print a file's size in bytes.

Parameters

  [in] | pr | Prtin stream for the output.

Returns
  The number of bytes printed.

## ◆ printModifyDateTime()

size_t ExFatFile::printModifyDateTime | ( | print_t * | pr | ) |
| inherited

Print a file's modify date and time

Parameters

  [in] | pr | Print stream for output.

Returns
  true for success or false for failure.

## ◆ printName()

size_t ExFatFile::printName | ( | print_t * | pr | ) |
| inherited

Print a file's name

Parameters

  [in] | pr | Print stream for output.

Returns
  true for success or false for failure.

## ◆ read() [1/2]

int StreamFile< ExFatFile , uint64_t >::read | ( |  | ) |
| inline inherited

Read the next byte from a file.

Returns
  For success return the next byte in the file as an int. If an error occurs or end of file is reached return -1.

## ◆ read() [2/2]

int ExFatFile::read | ( | void * | buf,
|  | size_t | count
| ) |  |
| inherited

Read data from a file starting at the current position.

Parameters

  [out] | buf | Pointer to the location that will receive the data.
  [in] | count | Maximum number of bytes to read.

Returns
  For success read() returns the number of bytes read. A value less than nbyte, including zero, will be returned if end of file is reached. If an error occurs, read() returns -1.

## ◆ remove() [1/2]

bool ExFatFile::remove | ( |  | ) |
| inherited

Remove a file.

The directory entry and all data for the file are deleted.

Note
  This function should not be used to delete the 8.3 version of a file that has a long name. For example if a file has the long name "New Text Document.txt" you should not delete the 8.3 name "NEWTEX~1.TXT".

Returns
  true for success or false for failure.

## ◆ remove() [2/2]

bool ExFatFile::remove | ( | const ExChar_t * | path | ) |
| inherited

Remove a file.

The directory entry and all data for the file are deleted.

Parameters

  [in] | path | Path for the file to be removed.

Example use: dirFile.remove(filenameToRemove);

Note
  This function should not be used to delete the 8.3 version of a file that has a long name. For example if a file has the long name "New Text Document.txt" you should not delete the 8.3 name "NEWTEX~1.TXT".

Returns
  true for success or false for failure.

## ◆ rename() [1/2]

bool ExFatFile::rename | ( | const ExChar_t * | newPath | ) |
| inherited

Rename a file or subdirectory.

Parameters

  [in] | newPath | New path name for the file/directory.

Returns
  true for success or false for failure.

## ◆ rename() [2/2]

bool ExFatFile::rename | ( | ExFatFile * | dirFile,
|  | const ExChar_t * | newPath
| ) |  |
| inherited

Rename a file or subdirectory.

Parameters

  [in] | dirFile | Directory for the new path.
  [in] | newPath | New path name for the file/directory.

Returns
  true for success or false for failure.

## ◆ rewind()

void ExFatFile::rewind | ( |  | ) |
| inline inherited

Set the file's current position to zero.

## ◆ rewindDirectory()

void StreamFile< ExFatFile , uint64_t >::rewindDirectory | ( |  | ) |
| inline inherited

Rewind a file if it is a directory

## ◆ rmdir()

bool ExFatFile::rmdir | ( |  | ) |
| inherited

Remove a directory file.

The directory file will be removed only if it is empty and is not the root directory. rmdir() follows DOS and Windows and ignores the read-only attribute for the directory.

Note
  This function should not be used to delete the 8.3 version of a directory that has a long name. For example if a directory has the long name "New folder" you should not delete the 8.3 name "NEWFOL~1".

Returns
  true for success or false for failure.

## ◆ seek()

bool StreamFile< ExFatFile , uint64_t >::seek | ( | uint64_t | pos | ) |
| inline inherited

Seek to a new position in the file, which must be between 0 and the size of the file (inclusive).

Parameters

  [in] | pos | the new file position.

Returns
  true for success or false for failure.

## ◆ seekCur()

bool ExFatFile::seekCur | ( | int64_t | offset | ) |
| inline inherited

Set the files position to current position + pos. See seekSet().

Parameters

  [in] | offset | The new position in bytes from the current position.

Returns
  true for success or false for failure.

## ◆ seekEnd()

bool ExFatFile::seekEnd | ( | int64_t | offset = `0` | ) |
| inline inherited

Set the files position to end-of-file + offset. See seekSet(). Can't be used for directory files since file size is not defined.

Parameters

  [in] | offset | The new position in bytes from end-of-file.

Returns
  true for success or false for failure.

## ◆ seekSet()

bool ExFatFile::seekSet | ( | uint64_t | pos | ) |
| inherited

Sets a file's position.

Parameters

  [in] | pos | The new position in bytes from the beginning of the file.

Returns
  true for success or false for failure.

## ◆ size()

uint64_t StreamFile< ExFatFile , uint64_t >::size | ( |  | ) |
| inline inherited

Returns
  the file's size.

## ◆ sync()

bool ExFatFile::sync | ( |  | ) |
| inherited

The sync() call causes all modified data and directory fields to be written to the storage device.

Returns
  true for success or false for failure.

## ◆ timestamp()

bool ExFatFile::timestamp | ( | uint8_t | flags,
|  | uint16_t | year,
|  | uint8_t | month,
|  | uint8_t | day,
|  | uint8_t | hour,
|  | uint8_t | minute,
|  | uint8_t | second
| ) |  |
| inherited

Truncate a file at the current file position.

Returns
  true for success or false for failure. Set a file's timestamps in its directory entry.

Parameters

  [in] | flags | Values for flags are constructed by a bitwise-inclusive OR of flags from the following list

T_ACCESS - Set the file's last access date and time.

T_CREATE - Set the file's creation date and time.

T_WRITE - Set the file's last write/modification date and time.

Parameters

  [in] | year | Valid range 1980 - 2107 inclusive.
  [in] | month | Valid range 1 - 12 inclusive.
  [in] | day | Valid range 1 - 31 inclusive.
  [in] | hour | Valid range 0 - 23 inclusive.
  [in] | minute | Valid range 0 - 59 inclusive.
  [in] | second | Valid range 0 - 59 inclusive

Note
  It is possible to set an invalid date since there is no check for the number of days in a month.
  Modify and access timestamps may be overwritten if a date time callback function has been set by dateTimeCallback().

Returns
  true for success or false for failure.

## ◆ truncate() [1/2]

bool ExFatFile::truncate | ( |  | ) |
| inherited

Truncate a file at the current file position. will be maintained if it is less than or equal to length otherwise it will be set to end of file.

Returns
  true for success or false for failure.

## ◆ truncate() [2/2]

bool ExFatFile::truncate | ( | uint64_t | length | ) |
| inline inherited

Truncate a file to a specified length. The current file position will be set to end of file.

Parameters

  [in] | length | The desired length for the file.

Returns
  true for success or false for failure.

## ◆ validLength()

uint64_t ExFatFile::validLength | ( |  | ) |
| inline inherited

Returns
  The valid number of bytes in a file.

## ◆ write() [1/4]

size_t ExFatFile::write | ( | const char * | str | ) |
| inline inherited

Write a string to a file. Used by the Arduino Print class.

Parameters

  [in] | str | Pointer to the string. Use getWriteError to check for errors.

Returns
  count of characters written for success or -1 for failure.

## ◆ write() [2/4]

size_t StreamFile< ExFatFile , uint64_t >::write | ( | const uint8_t * | buffer,
|  | size_t | size
| ) |  |
| inline inherited

Write data to an open file.

Note
  Data is moved to the cache but may not be written to the storage device until sync() is called.

Parameters

  [in] | buffer | Pointer to the location of the data to be written.
  [in] | size | Number of bytes to write.

Returns
  For success write() returns the number of bytes written, always size.

## ◆ write() [3/4]

size_t ExFatFile::write | ( | const void * | buf,
|  | size_t | count
| ) |  |
| inherited

Write data to an open file.

Note
  Data is moved to the cache but may not be written to the storage device until sync() is called.

Parameters

  [in] | buf | Pointer to the location of the data to be written.
  [in] | count | Number of bytes to write.

Returns
  For success write() returns the number of bytes written, always count.

## ◆ write() [4/4]

size_t StreamFile< ExFatFile , uint64_t >::write | ( | uint8_t | b | ) |
| inline inherited

Write a byte to a file. Required by the Arduino Print class.

Parameters

  [in] | b | the byte to be written. Use getWriteError to check for errors.

Returns
  1 for success and 0 for failure.

The documentation for this class was generated from the following file:

- Arduino/libraries/SdFat/src/ExFatLib/ExFatFile.h